summarylogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--.SRCINFO128
-rw-r--r--PKGBUILD194
-rw-r--r--arch.conf7
-rw-r--r--initcpio-hook-udev22
-rw-r--r--initcpio-install-systemd170
-rw-r--r--initcpio-install-udev28
-rw-r--r--loader.conf1
-rw-r--r--systemd-git.install205
8 files changed, 755 insertions, 0 deletions
diff --git a/.SRCINFO b/.SRCINFO
new file mode 100644
index 00000000000..877b17aca3a
--- /dev/null
+++ b/.SRCINFO
@@ -0,0 +1,128 @@
+pkgbase = systemd
+ pkgver = 227.r255.g931c7fe
+ pkgrel = 1
+ url = http://www.freedesktop.org/wiki/Software/systemd
+ arch = i686
+ arch = x86_64
+ makedepends = acl
+ makedepends = cryptsetup
+ makedepends = docbook-xsl
+ makedepends = gperf
+ makedepends = lz4
+ makedepends = xz
+ makedepends = pam
+ makedepends = intltool
+ makedepends = iptables
+ makedepends = kmod
+ makedepends = libcap
+ makedepends = libidn
+ makedepends = libgcrypt
+ makedepends = libmicrohttpd
+ makedepends = libxslt
+ makedepends = util-linux
+ makedepends = linux-api-headers
+ makedepends = python-lxml
+ makedepends = quota-tools
+ makedepends = shadow
+ makedepends = gnu-efi-libs
+ makedepends = git
+ options = strip
+ options = debug
+ source = git://github.com/systemd/systemd.git#branch=master
+ source = initcpio-hook-udev
+ source = initcpio-install-systemd
+ source = initcpio-install-udev
+ source = arch.conf
+ source = loader.conf
+ md5sums = SKIP
+ md5sums = 90ea67a7bb237502094914622a39e281
+ md5sums = 976c5511b6493715e381f43f16cdb151
+ md5sums = 1b3aa3a0551b08af9305d33f85b5c2fc
+ md5sums = 20ead378f5d6df4b2a3e670301510a7d
+ md5sums = ddaef54f68f6c86c6c07835fc668f62a
+
+pkgname = systemd-git
+ pkgdesc = system and service manager
+ install = systemd-git.install
+ license = GPL2
+ license = LGPL2.1
+ depends = acl
+ depends = bash
+ depends = dbus
+ depends = iptables
+ depends = kbd
+ depends = kmod
+ depends = hwids
+ depends = libcap
+ depends = libgcrypt
+ depends = libsystemd
+ depends = libidn
+ depends = lz4
+ depends = pam
+ depends = libseccomp
+ depends = util-linux
+ depends = xz
+ optdepends = cryptsetup: required for encrypted block devices
+ optdepends = libmicrohttpd: remote journald capabilities
+ optdepends = quota-tools: kernel-level quota management
+ optdepends = systemd-sysvcompat: symlink package to provide sysvinit binaries
+ optdepends = polkit: allow administration as unprivileged user
+ provides = systemd=227.r255.g931c7fe
+ provides = nss-myhostname
+ provides = systemd-tools=227.r255.g931c7fe
+ provides = udev=227.r255.g931c7fe
+ conflicts = nss-myhostname
+ conflicts = systemd-tools
+ conflicts = udev
+ conflicts = systemd
+ replaces = nss-myhostname
+ replaces = systemd-tools
+ replaces = udev
+ replaces = systemd
+ backup = etc/dbus-1/system.d/org.freedesktop.systemd1.conf
+ backup = etc/dbus-1/system.d/org.freedesktop.hostname1.conf
+ backup = etc/dbus-1/system.d/org.freedesktop.login1.conf
+ backup = etc/dbus-1/system.d/org.freedesktop.locale1.conf
+ backup = etc/dbus-1/system.d/org.freedesktop.machine1.conf
+ backup = etc/dbus-1/system.d/org.freedesktop.timedate1.conf
+ backup = etc/dbus-1/system.d/org.freedesktop.import1.conf
+ backup = etc/dbus-1/system.d/org.freedesktop.network1.conf
+ backup = etc/pam.d/systemd-user
+ backup = etc/systemd/bootchart.conf
+ backup = etc/systemd/coredump.conf
+ backup = etc/systemd/journald.conf
+ backup = etc/systemd/journal-remote.conf
+ backup = etc/systemd/journal-upload.conf
+ backup = etc/systemd/logind.conf
+ backup = etc/systemd/system.conf
+ backup = etc/systemd/timesyncd.conf
+ backup = etc/systemd/resolved.conf
+ backup = etc/systemd/user.conf
+ backup = etc/udev/udev.conf
+
+pkgname = libsystemd-git
+ pkgdesc = systemd client libraries
+ license = GPL2
+ depends = glibc
+ depends = libgcrypt
+ depends = lz4
+ depends = xz
+ provides = libsystemd
+ provides = libsystemd-git
+ provides = libsystemd.so
+ provides = libudev.so
+ provides = libsystemd-id128.so
+ provides = libsystemd-journal.so
+ provides = libsystemd-login.so
+ provides = libsystemd-daemon.so
+ conflicts = libsystemd
+ replaces = libsystemd
+
+pkgname = systemd-sysvcompat-git
+ pkgdesc = sysvinit compat for systemd
+ groups = base
+ license = GPL2
+ depends = systemd
+ conflicts = systemd-sysvcompat
+ replaces = systemd-sysvcompat
+
diff --git a/PKGBUILD b/PKGBUILD
new file mode 100644
index 00000000000..f685e48e924
--- /dev/null
+++ b/PKGBUILD
@@ -0,0 +1,194 @@
+# Maintainer: Yurii Kolesnykov <yurikoles@gmail.com>
+# Contributor: Dave Reisner <dreisner@archlinux.org>
+# Contributor: Tom Gundersen <teg@jklm.no>
+
+pkgbase=systemd-git
+pkgname=('systemd-git' 'libsystemd-git' 'systemd-sysvcompat-git')
+pkgver=227.r255.g931c7fe
+pkgrel=1
+arch=('i686' 'x86_64')
+url="http://www.freedesktop.org/wiki/Software/systemd"
+conflicts=
+makedepends=('acl' 'cryptsetup' 'docbook-xsl' 'gperf' 'lz4' 'xz' 'pam'
+ 'intltool' 'iptables' 'kmod' 'libcap' 'libidn' 'libgcrypt'
+ 'libmicrohttpd' 'libxslt' 'util-linux' 'linux-api-headers'
+ 'python-lxml' 'quota-tools' 'shadow' 'gnu-efi-libs' 'git')
+options=('strip' 'debug')
+source=("systemd-git::git://github.com/systemd/systemd.git#branch=master"
+ 'initcpio-hook-udev'
+ 'initcpio-install-systemd'
+ 'initcpio-install-udev'
+ 'arch.conf'
+ 'loader.conf')
+ #'splash-arch.bmp'
+
+md5sums=('SKIP'
+ '90ea67a7bb237502094914622a39e281'
+ '976c5511b6493715e381f43f16cdb151'
+ '1b3aa3a0551b08af9305d33f85b5c2fc'
+ '20ead378f5d6df4b2a3e670301510a7d'
+ 'ddaef54f68f6c86c6c07835fc668f62a')
+ #'1e2f9a8b0fa32022bf0a8f39123e5f4e'
+
+pkgver() {
+ cd "${srcdir}/$pkgbase"
+ # cutting off 'foo-' prefix that presents in the git tag
+ git describe --long | sed 's/^v//;s/\([^-]*-g\)/r\1/;s/-/./g'
+}
+
+prepare() {
+ cd "$pkgbase"
+
+ ./autogen.sh
+}
+
+build() {
+ cd "$pkgbase"
+
+ local timeservers=({0..3}.arch.pool.ntp.org)
+
+ ./configure \
+ --libexecdir=/usr/lib \
+ --localstatedir=/var \
+ --sysconfdir=/etc \
+ --enable-lz4 \
+ --enable-compat-libs \
+ --enable-gnuefi \
+ --disable-audit \
+ --disable-ima \
+ --with-sysvinit-path= \
+ --with-sysvrcnd-path= \
+ --with-ntp-servers="${timeservers[*]}"
+
+ make
+}
+
+package_systemd-git() {
+ pkgdesc="system and service manager"
+ license=('GPL2' 'LGPL2.1')
+ depends=('acl' 'bash' 'dbus' 'iptables' 'kbd' 'kmod' 'hwids' 'libcap'
+ 'libgcrypt' 'libsystemd' 'libidn' 'lz4' 'pam' 'libseccomp'
+ 'util-linux' 'xz')
+ provides=("systemd=$pkgver" 'nss-myhostname' "systemd-tools=$pkgver" "udev=$pkgver" )
+ replaces=('nss-myhostname' 'systemd-tools' 'udev' systemd)
+ conflicts=('nss-myhostname' 'systemd-tools' 'udev' systemd)
+ optdepends=('cryptsetup: required for encrypted block devices'
+ 'libmicrohttpd: remote journald capabilities'
+ 'quota-tools: kernel-level quota management'
+ 'systemd-sysvcompat: symlink package to provide sysvinit binaries'
+ 'polkit: allow administration as unprivileged user')
+ backup=(etc/dbus-1/system.d/org.freedesktop.systemd1.conf
+ etc/dbus-1/system.d/org.freedesktop.hostname1.conf
+ etc/dbus-1/system.d/org.freedesktop.login1.conf
+ etc/dbus-1/system.d/org.freedesktop.locale1.conf
+ etc/dbus-1/system.d/org.freedesktop.machine1.conf
+ etc/dbus-1/system.d/org.freedesktop.timedate1.conf
+ etc/dbus-1/system.d/org.freedesktop.import1.conf
+ etc/dbus-1/system.d/org.freedesktop.network1.conf
+ etc/pam.d/systemd-user
+ etc/systemd/bootchart.conf
+ etc/systemd/coredump.conf
+ etc/systemd/journald.conf
+ etc/systemd/journal-remote.conf
+ etc/systemd/journal-upload.conf
+ etc/systemd/logind.conf
+ etc/systemd/system.conf
+ etc/systemd/timesyncd.conf
+ etc/systemd/resolved.conf
+ etc/systemd/user.conf
+ etc/udev/udev.conf)
+ install="systemd-git.install"
+
+ make -C "$pkgbase" DESTDIR="$pkgdir" install
+
+ # don't write units to /etc by default. some of these will be re-enabled on
+ # post_install.
+ rm -r "$pkgdir/etc/systemd/system/"*.wants
+
+ # get rid of RPM macros
+ rm -r "$pkgdir/usr/lib/rpm"
+
+ # add back tmpfiles.d/legacy.conf
+ install -m644 "$pkgbase/tmpfiles.d/legacy.conf" "$pkgdir/usr/lib/tmpfiles.d"
+
+ # Replace dialout/tape/cdrom group in rules with uucp/storage/optical group
+ sed -i 's#GROUP="dialout"#GROUP="uucp"#g;
+ s#GROUP="tape"#GROUP="storage"#g;
+ s#GROUP="cdrom"#GROUP="optical"#g' "$pkgdir"/usr/lib/udev/rules.d/*.rules
+ sed -i 's/dialout/uucp/g;
+ s/tape/storage/g;
+ s/cdrom/optical/g' "$pkgdir"/usr/lib/sysusers.d/basic.conf
+
+ # add mkinitcpio hooks
+ install -Dm644 "$srcdir/initcpio-install-systemd" "$pkgdir/usr/lib/initcpio/install/systemd"
+ install -Dm644 "$srcdir/initcpio-install-udev" "$pkgdir/usr/lib/initcpio/install/udev"
+ install -Dm644 "$srcdir/initcpio-hook-udev" "$pkgdir/usr/lib/initcpio/hooks/udev"
+
+ # ensure proper permissions for /var/log/journal. This is only to placate
+ chown root:systemd-journal "$pkgdir/var/log/journal"
+ chmod 2755 "$pkgdir/var/log/journal"
+
+ # we'll create this on installation
+ rmdir "$pkgdir/var/log/journal/remote"
+
+ # fix pam file
+ sed 's|system-auth|system-login|g' -i "$pkgdir/etc/pam.d/systemd-user"
+
+ # ship default policy to leave services disabled
+ echo 'disable *' >"$pkgdir"/usr/lib/systemd/system-preset/99-default.preset
+
+ ### manpages shipped with systemd-sysvcompat
+ rm "$pkgdir"/usr/share/man/man8/{telinit,halt,reboot,poweroff,runlevel,shutdown}.8
+
+ ### runtime libraries shipped with libsystemd
+ rm "$pkgdir"/usr/lib/lib{nss,systemd,udev}*.so*
+
+ # add example bootctl configuration
+ install -Dm644 "$srcdir/arch.conf" "$pkgdir"/usr/share/systemd/bootctl/arch.conf
+ install -Dm644 "$srcdir/loader.conf" "$pkgdir"/usr/share/systemd/bootctl/loader.conf
+ #install -Dm644 "$srcdir/splash-arch.bmp" "$pkgdir"/usr/share/systemd/bootctl/splash-arch.bmp
+}
+
+package_libsystemd-git() {
+ pkgdesc="systemd client libraries"
+ depends=('glibc' 'libgcrypt' 'lz4' 'xz')
+ license=('GPL2')
+ provides=('libsystemd'
+ 'libsystemd-git'
+ 'libsystemd.so'
+ 'libudev.so'
+ 'libsystemd-id128.so'
+ 'libsystemd-journal.so'
+ 'libsystemd-login.so'
+ 'libsystemd-daemon.so')
+ replaces=('libsystemd')
+ conflicts=('libsystemd')
+
+
+ make -C "$pkgbase" DESTDIR="$pkgdir" install-libLTLIBRARIES
+}
+
+package_systemd-sysvcompat-git() {
+ pkgdesc="sysvinit compat for systemd"
+ license=('GPL2')
+ groups=('base')
+ conflicts=('sysvinit' 'systemd-sysvcompat')
+ depends=('systemd')
+ replaces=('systemd-sysvcompat')
+ conflicts=('systemd-sysvcompat')
+
+
+ install -dm755 "$pkgdir"/usr/share/man/man8
+ cp -d --no-preserve=ownership,timestamp \
+ "$pkgbase"/man/{telinit,halt,reboot,poweroff,runlevel,shutdown}.8 \
+ "$pkgdir"/usr/share/man/man8
+
+ install -dm755 "$pkgdir/usr/bin"
+ for tool in runlevel reboot shutdown poweroff halt telinit; do
+ ln -s 'systemctl' "$pkgdir/usr/bin/$tool"
+ done
+
+ ln -s '../lib/systemd/systemd' "$pkgdir/usr/bin/init"
+}
+
+# vim: ft=sh syn=sh et
diff --git a/arch.conf b/arch.conf
new file mode 100644
index 00000000000..250b7785e94
--- /dev/null
+++ b/arch.conf
@@ -0,0 +1,7 @@
+## This is just an example config file.
+## Please edit the paths and kernel parameters according to your system.
+
+title Arch Linux
+linux /vmlinuz-linux
+initrd /initramfs-linux.img
+options root=PARTUUID=XXXX rootfstype=XXXX add_efi_memmap
diff --git a/initcpio-hook-udev b/initcpio-hook-udev
new file mode 100644
index 00000000000..ea9a11f8ce8
--- /dev/null
+++ b/initcpio-hook-udev
@@ -0,0 +1,22 @@
+#!/usr/bin/ash
+
+run_earlyhook() {
+ kmod static-nodes --format=tmpfiles --output=/run/tmpfiles.d/kmod.conf
+ systemd-tmpfiles --prefix=/dev --create --boot
+ /usr/lib/systemd/systemd-udevd --daemon --resolve-names=never
+ udevd_running=1
+}
+
+run_hook() {
+ msg ":: Triggering uevents..."
+ udevadm trigger --action=add --type=subsystems
+ udevadm trigger --action=add --type=devices
+ udevadm settle
+}
+
+run_cleanuphook() {
+ udevadm control --exit
+ udevadm info --cleanup-db
+}
+
+# vim: set ft=sh ts=4 sw=4 et:
diff --git a/initcpio-install-systemd b/initcpio-install-systemd
new file mode 100644
index 00000000000..96df98ada27
--- /dev/null
+++ b/initcpio-install-systemd
@@ -0,0 +1,170 @@
+#!/bin/bash
+
+strip_quotes() {
+ local len=${#1} quotes=$'[\'"]' str=${!1}
+
+ if [[ ${str:0:1} = ${str: -1} && ${str:0:1} = $quotes ]]; then
+ printf -v "$1" %s "${str:1:-1}"
+ fi
+}
+
+add_udev_rule() {
+ # Add an udev rules file to the initcpio image. Dependencies on binaries
+ # will be discovered and added.
+ # $1: path to rules file (or name of rules file)
+
+ local rules= rule= key= value= binary=
+
+ rules=$(PATH=/usr/lib/udev/rules.d:/lib/udev/rules.d type -P "$1")
+ if [[ -z $rules ]]; then
+ # complain about not found rules
+ return 1
+ fi
+
+ add_file "$rules"
+
+ while IFS=, read -ra rule; do
+ # skip empty lines, comments
+ [[ -z $rule || $rule = @(+([[:space:]])|#*) ]] && continue
+
+ for pair in "${rule[@]}"; do
+ IFS=' =' read -r key value <<< "$pair"
+ case $key in
+ RUN@({program}|+)|IMPORT{program}|ENV{REMOVE_CMD})
+ strip_quotes 'value'
+ # just take the first word as the binary name
+ binary=${value%% *}
+ [[ ${binary:0:1} == '$' ]] && continue
+ if [[ ${binary:0:1} != '/' ]]; then
+ binary=$(PATH=/usr/lib/udev:/lib/udev type -P "$binary")
+ fi
+ add_binary "$binary"
+ ;;
+ esac
+ done
+ done <"$rules"
+}
+
+add_systemd_unit() {
+ # Add a systemd unit file to the initcpio image. Hard dependencies on binaries
+ # and other unit files will be discovered and added.
+ # $1: path to rules file (or name of rules file)
+
+ local unit= rule= entry= key= value= binary= dep=
+
+ unit=$(PATH=/usr/lib/systemd/system:/lib/systemd/system type -P "$1")
+ if [[ -z $unit ]]; then
+ # complain about not found unit file
+ return 1
+ fi
+
+ add_file "$unit"
+
+ while IFS='=' read -r key values; do
+ read -ra values <<< "$values"
+
+ case $key in
+ Requires|OnFailure)
+ # only add hard dependencies (not Wants)
+ map add_systemd_unit "${values[@]}"
+ ;;
+ Exec*)
+ # don't add binaries unless they are required
+ if [[ ${values[0]:0:1} != '-' ]]; then
+ add_binary "${values[0]}"
+ fi
+ ;;
+ esac
+
+ done <"$unit"
+
+ # preserve reverse soft dependency
+ for dep in {/usr,}/lib/systemd/system/*.wants/${unit##*/}; do
+ if [[ -L $dep ]]; then
+ add_symlink "$dep"
+ fi
+ done
+
+ # add hard dependencies
+ if [[ -d $unit.requires ]]; then
+ for dep in "$unit".requires/*; do
+ add_systemd_unit ${dep##*/}
+ done
+ fi
+}
+
+build() {
+ local rules unit
+
+ # from base
+ add_binary /bin/mount
+ add_binary /usr/bin/kmod /usr/bin/modprobe
+ add_binary /usr/lib/systemd/systemd /init
+
+ map add_binary \
+ /usr/bin/systemd-tmpfiles \
+ /usr/lib/systemd/systemd-hibernate-resume \
+ /usr/lib/systemd/system-generators/systemd-fstab-generator \
+ /usr/lib/systemd/system-generators/systemd-gpt-auto-generator \
+ /usr/lib/systemd/system-generators/systemd-hibernate-resume-generator
+
+ add_module "kdbus?"
+
+ # udev rules and systemd units
+ map add_udev_rule "$rules" \
+ 50-udev-default.rules \
+ 60-persistent-storage.rules \
+ 64-btrfs.rules \
+ 80-drivers.rules \
+ 99-systemd.rules
+
+ map add_systemd_unit \
+ initrd-cleanup.service \
+ initrd-fs.target \
+ initrd-parse-etc.service \
+ initrd-root-fs.target \
+ initrd-switch-root.service \
+ initrd-switch-root.target \
+ initrd-udevadm-cleanup-db.service \
+ initrd.target \
+ kmod-static-nodes.service \
+ local-fs.target \
+ local-fs-pre.target \
+ paths.target \
+ reboot.target \
+ slices.target \
+ sockets.target \
+ swap.target \
+ systemd-fsck@.service \
+ systemd-hibernate-resume@.service \
+ systemd-journald.service \
+ systemd-journald-audit.socket \
+ systemd-journald-dev-log.socket \
+ systemd-tmpfiles-setup-dev.service \
+ systemd-udev-trigger.service \
+ systemd-udevd-control.socket \
+ systemd-udevd-kernel.socket \
+ systemd-udevd.service \
+ timers.target
+
+ add_symlink "/usr/lib/systemd/system/default.target" "initrd.target"
+ add_symlink "/usr/lib/systemd/system/ctrl-alt-del.target" "reboot.target"
+
+ # udev wants /etc/group since it doesn't launch with --resolve-names=never
+ add_file "/etc/nsswitch.conf"
+ add_binary "$(readlink -f /usr/lib/libnss_files.so)"
+ add_file "/etc/passwd"
+ add_file "/etc/group"
+}
+
+help() {
+ cat <<HELPEOF
+This will install a basic systemd setup in your initramfs, and is meant to
+replace the 'base', 'usr', 'udev' and 'timestamp' hooks. Other hooks with runtime
+components will need to be ported, and will not work as intended. You also may
+wish to still include the 'base' hook (before this hook) to ensure that a
+rescue shell exists on your initramfs.
+HELPEOF
+}
+
+# vim: set ft=sh ts=4 sw=4 et:
diff --git a/initcpio-install-udev b/initcpio-install-udev
new file mode 100644
index 00000000000..7f0301a4885
--- /dev/null
+++ b/initcpio-install-udev
@@ -0,0 +1,28 @@
+#!/bin/bash
+
+build() {
+ local rules tool
+
+ add_binary /usr/lib/systemd/systemd-udevd
+ add_binary /usr/bin/udevadm
+ add_binary /usr/bin/systemd-tmpfiles
+
+ for rules in 50-udev-default.rules 60-persistent-storage.rules 64-btrfs.rules 80-drivers.rules; do
+ add_file "/usr/lib/udev/rules.d/$rules"
+ done
+ for tool in ata_id scsi_id; do
+ add_file "/usr/lib/udev/$tool"
+ done
+
+ add_runscript
+}
+
+help() {
+ cat <<HELPEOF
+This hook will use udev to create your root device node and detect the needed
+modules for your root device. It is also required for firmware loading in
+initramfs. It is recommended to use this hook.
+HELPEOF
+}
+
+# vim: set ft=sh ts=4 sw=4 et:
diff --git a/loader.conf b/loader.conf
new file mode 100644
index 00000000000..1f7cd7ef493
--- /dev/null
+++ b/loader.conf
@@ -0,0 +1 @@
+default arch
diff --git a/systemd-git.install b/systemd-git.install
new file mode 100644
index 00000000000..b0a3e1fa4e4
--- /dev/null
+++ b/systemd-git.install
@@ -0,0 +1,205 @@
+#!/bin/bash
+
+sd_booted() {
+ [[ -d run/systemd/system && ! -L run/systemd/system ]]
+}
+
+add_privs() {
+ if ! setcap "$2" "$1" 2>/dev/null; then
+ echo "==> Warning: setcap failed, falling back to setuid root on /$1"
+ chmod u+s "$1"
+ fi
+}
+
+add_journal_acls() {
+ # ignore errors, since the filesystem might not support ACLs
+ setfacl -Rnm g:wheel:rx,d:g:wheel:rx,g:adm:rx,d:g:adm:rx var/log/journal/ 2>/dev/null
+ :
+}
+
+maybe_reexec() {
+ # don't reexec on 209-1 upgrade due to large infrastructural changes.
+ if [[ $(vercmp 209-1 "$2") -eq 1 ]]; then
+ echo ':: systemd has not been reexecuted. It is recommended that you'
+ echo ' reboot at your earliest convenience.'
+ return
+ fi
+
+ if sd_booted; then
+ systemctl --system daemon-reexec
+ fi
+}
+
+_dir_empty() {
+ set -- "$1"/*
+ [[ ! -e $1 && ! -L $1 ]]
+}
+
+post_common() {
+ systemd-sysusers
+ udevadm hwdb --update
+ journalctl --update-catalog
+}
+
+_204_1_changes() {
+ printf '==> The /bin/systemd symlink has been removed. Any references in your\n'
+ printf ' bootloader (or elsewhere) must be updated to /usr/lib/systemd/systemd.\n'
+}
+
+_205_1_changes() {
+ printf '==> systemd 205 restructures the cgroup hierarchy and changes internal\n'
+ printf ' protocols. You should reboot at your earliest convenience.\n'
+}
+
+_206_1_changes() {
+ printf '==> The "timestamp" hook for mkinitcpio no longer exists. If you used\n'
+ printf ' this hook, you must remove it from /etc/mkinitcpio.conf. A "systemd"\n'
+ printf ' hook has been added which provides this functionality, and more.\n'
+}
+
+_208_1_changes() {
+ if [[ -e var/lib/backlight && ! -e var/lib/systemd/backlight ]]; then
+ mv -T var/lib/backlight var/lib/systemd/backlight
+ fi
+
+ if [[ -e var/lib/random-seed && ! -e var/lib/systemd/random-seed ]]; then
+ mv -T var/lib/random-seed var/lib/systemd/random-seed
+ fi
+}
+
+_208_8_changes() {
+ add_journal_acls
+}
+
+_209_1_changes() {
+ # attempt to preserve existing behavior
+
+ local old_rule=etc/udev/rules.d/80-net-name-slot.rules
+ local new_rule=etc/udev/rules.d/80-net-setup-link.rules
+
+ echo ":: Network device naming is now controlled by udev's net_setup_link"
+ echo " builtin. Refer to the systemd.link manpage for a full description."
+
+ # not clear what action we can take here, so don't do anything
+ [[ -e $new_rule ]] && return 0
+
+ # rename the old rule to the new one so that we preserve the user's
+ # existing option.
+ if [[ -e $old_rule ]]; then
+ printf ':: Renaming %s to %s in order\n' "${old_rule##*/}" "${new_rule##*/}"
+ printf ' to preserve existing network naming behavior.\n'
+ mv -v "$old_rule" "$new_rule"
+ else
+ echo ':: No changes have been made to your network naming configuration.'
+ echo ' Interfaces should continue to maintain the same names.'
+ fi
+}
+
+_210_1_changes() {
+ if sd_booted; then
+ # If /etc/systemd/network is non-empty, then this is a 209 user who used
+ # networkd. Re-enable it for them.
+ if ! _dir_empty etc/systemd/network; then
+ systemctl enable systemd-networkd
+ fi
+ fi
+}
+
+_213_4_changes() {
+ if sd_booted; then
+ # if /etc/resolv.conf is a symlink, just assume that it was being managed
+ # by systemd-networkd, and re-enable systemd-resolved.
+ if [[ -L etc/resolv.conf ]]; then
+ systemctl enable systemd-resolved
+ fi
+ fi
+}
+
+_214_2_changes() {
+ # /run/systemd/network/resolv.conf -> /run/systemd/resolve/resolv.conf
+ if [[ etc/resolv.conf -ef run/systemd/network/resolv.conf ]]; then
+ ln -sf /run/systemd/resolve/resolv.conf /etc/resolv.conf
+
+ if sd_booted; then
+ if [[ ! -d run/systemd/resolve ]]; then
+ mkdir run/systemd/resolve
+ fi
+
+ if [[ -f run/systemd/network/resolv.conf ]]; then
+ mv run/systemd/{network,resolve}/resolv.conf
+ fi
+ fi
+ fi
+
+ echo ':: coredumps are no longer sent to the journal by default. To re-enable:'
+ echo ' echo >/etc/sysctl.d/50-coredump.conf \'
+ echo ' "kernel.core_pattern=|/usr/lib/systemd/systemd-coredump %p %u %g %s %t %e"'
+}
+
+_215_2_changes() {
+ # create at least the symlink from /etc/os-release to /usr/lib/os-release
+ systemd-tmpfiles --create etc.conf
+}
+
+_216_2_changes() {
+ echo ':: Coredumps are handled by systemd by default. Collection behavior can be'
+ echo ' tuned in /etc/systemd/coredump.conf.'
+}
+
+_219_2_changes() {
+ if mkdir -m2755 var/log/journal/remote 2>/dev/null; then
+ chgrp systemd-journal-remote var/log/journal/remote
+ fi
+}
+
+_219_4_changes() {
+ if ! systemctl is-enabled -q remote-fs.target; then
+ systemctl enable -q remote-fs.target
+ fi
+}
+
+post_install() {
+ systemd-machine-id-setup
+
+ post_common "$@"
+
+ add_journal_acls
+
+ # enable some services by default, but don't track them
+ systemctl enable getty@tty1.service remote-fs.target
+
+ echo ":: Append 'init=/usr/lib/systemd/systemd' to your kernel command line in your"
+ echo " bootloader to replace sysvinit with systemd, or install systemd-sysvcompat"
+
+ # group 'systemd-journal-remote' is created by systemd-sysusers
+ mkdir -m2755 var/log/journal/remote
+ chgrp systemd-journal-remote var/log/journal/remote
+}
+
+post_upgrade() {
+ post_common "$@"
+
+ maybe_reexec "$@"
+
+ local v upgrades=(204-1
+ 205-1
+ 206-1
+ 208-1
+ 208-8
+ 209-1
+ 210-1
+ 213-4
+ 214-2
+ 215-2
+ 216-2
+ 219-2
+ 219-4)
+
+ for v in "${upgrades[@]}"; do
+ if [[ $(vercmp "$v" "$2") -eq 1 ]]; then
+ "_${v//-/_}_changes"
+ fi
+ done
+}
+
+# vim:set ts=2 sw=2 et: